//
//  funzioni.c
//  Pumo Matteo Corso C
//
//  Created by Matteo Pumo on 23/02/13.
//  Copyright (c) 2013 Matteo Pumo. All rights reserved.
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "funzioni.h"

Persona* leggiFile(char *nomeFile, int *dim)
{
    FILE *fo;
    Persona *arrayPersone2;
    char nome[31], cognome[31];
    int eta, i;
    
    fo = fopen(nomeFile, "r");
    if (fo == NULL){
        perror("Error opening file");
        exit(1);
    }
    
    // Ricordo che *dim è un puntatore...
    *dim = 0;
    while (!feof(fo)){ // Fino a che non è finito il file
        fscanf(fo, "%s%s%d", nome, cognome, &eta);
        (*dim)++;
    }
    // Faccio tornare la testina di lettura/scrittura all'inizio del file
    rewind(fo); 
    
    // Alloco dinamicamente memoria per *dim strutture
    arrayPersone2 = (Persona*) malloc(sizeof(Persona) * *dim);
    
    i = 0;
    while (!feof(fo)){ 
        fscanf(fo, "%s%s%d", arrayPersone2[i].nome, arrayPersone2[i].cognome, &arrayPersone2[i].eta);
        i++;
    }
    
    fclose(fo);
    return arrayPersone2;
}


void visualizzaArrayStrutture(Persona *arrayStruct, int dim)
{
    int i;
    for (i=0; i<dim; i++)
        printf("Nome: %s %s, Eta': %d\n", arrayStruct[i].nome, arrayStruct[i].cognome, arrayStruct[i].eta);
}

Persona piuGrande(Persona *arrayPersone, int dim)
{
    int i, max = arrayPersone[0].eta;
    Persona temp;
    
    for (i=1; i<dim; i++){
        if (arrayPersone[i].eta > max){
            max = arrayPersone[i].eta;
            strcpy(temp.nome, arrayPersone[i].nome);
            strcpy(temp.cognome, arrayPersone[i].cognome);
        }
    }
    return temp;
}

